%define name    smokeping
%define version 1.23
%define release 1
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%define url	http://people.ee.ethz.ch/~oetiker/webtools/%{name}/

Summary: latency logging and graphing system
Name:           %{name}
Version:        %{version}
Release:        %{release}
License:        GPL
Group:		Applications/Internet
URL:		%{url}

Source0:	%{url}/pub/%{name}-%{version}.tar.bz2
Source1:	%{name}.init
Source2:	%{name}-config
Source3:	%{name}-httpd.conf
Patch0:		%{name}-maxhight.patch

BuildArch:	noarch
BuildRequires:	perl grep
Requires:	perl >= 5.6.1
Requires:	rrdtool >= 1.0.33
Requires:	fping >= 2.4b2
Requires:	echoping >= 4.2.0
#Requires:	apache >= 1.3.19
Requires:	webserver
Requires:	net-tools
Requires:	perl(Net::SMTP)
# disabled speedycgi for first rpm release (using straight perl)
#Requires:	SpeedyCGI
# better yet...can I make it work under mod_perl?

%description
SmokePing is a latency logging and graphing system. It
consists of a daemon process which organizes the latency
measurements and a CGI which presents the graphs.

%prep
%setup -q
cp -p %{SOURCE2} etc/config
%patch0

%build
decruft() { perl -pi -e "s|$1|$2|g" `grep -lr "$1" *` ;}

# eliminate Tobi's quirks
decruft /usr/sepp/bin %{_bindir}
decruft /home/oetiker/.smokeping				%{_sysconfdir}/%{name}
decruft /home/oetiker/data/projects/AADJ-smokeping/dist/etc	%{_sysconfdir}/%{name}
decruft /home/oetiker/data/projects/AADJ-smokeping/dist/lib	%{_libdir}/%{name}

# rrdtool package goes into standard perl tree
decruft '^use lib qw./usr/pack/rrdtool-1.0.33-to/lib/perl.;' ''

# disabled SpeedyCGI for now...
decruft /usr/bin/speedy %{__perl}

%install
rm -rf $RPM_BUILD_ROOT

install -Dpm755 bin/%{name}.dist	$RPM_BUILD_ROOT/%{_bindir}/%{name}

mkdir -p				$RPM_BUILD_ROOT/%{_libdir}/%{name}
cp -pr lib/*				$RPM_BUILD_ROOT/%{_libdir}/%{name}/

mkdir -p				$RPM_BUILD_ROOT/%{_localstatedir}/%{name}/{rrd,img}
install -Dpm755 htdocs/%{name}.cgi.dist	$RPM_BUILD_ROOT/%{_localstatedir}/www/cgi-bin/%{name}

install -Dpm755 %{SOURCE1}		$RPM_BUILD_ROOT/%{_sysconfdir}/rc.d/init.d/%{name}
install -Dpm644 etc/config		$RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/config.dist
install -Dpm644 etc/config		$RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/config
install -Dpm644 etc/basepage.html.dist	$RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/basepage.html
install -Dpm644 etc/smokemail.dist 	$RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/smokemail

install -D -pm644 %{SOURCE3}		$RPM_BUILD_ROOT/%{_sysconfdir}/httpd/conf/%{name}.conf

mkdir -p				$RPM_BUILD_ROOT/%{_mandir}/man1
install -p -m644 doc/*.1		$RPM_BUILD_ROOT/%{_mandir}/man1/

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ "$1" = "1" ]; then

# for first time install, monitor our default gateway and name servers
firstgate=`route -n |awk '$1=="0.0.0.0" && $4 ~ /G/ {print $2}' |head -1`
echo "
+ gateway
 menu	= Default Gateway
 title	= Default Gateway Router
 host	= $firstgate

+ dns
 menu	= DNS Servers
 title	= Domain Name Servers
	" >>%{_sysconfdir}/%{name}/config
for dns in `awk '$1 ~ /^nameserver/ {print $2}' %{_sysconfdir}/resolv.conf |sort -u` ; do
((dnscnt++))
echo "++ dns$dnscnt
  menu	= DNS Server $dnscnt
  title	= Domain Name Server $dnscnt
  host	= $dns
	" >>%{_sysconfdir}/%{name}/config
done

[ "$HOSTNAME" ] && %{__perl} -pi -e "s|localhost|$HOSTNAME|g" %{_sysconfdir}/%{name}/config

fi

if [ -d %{_sysconfdir}/httpd/conf.d ] ; then
    ln -s %{_sysconfdir}/httpd/conf/%{name}.conf %{_sysconfdir}/httpd/conf.d/%{name}.conf
else
egrep -q '^[[:space:]]*Include %{_sysconfdir}/httpd/conf/%{name}.conf' %{_sysconfdir}/httpd/conf/httpd.conf || {
    echo 'Include %{_sysconfdir}/httpd/conf/%{name}.conf' >>%{_sysconfdir}/httpd/conf/httpd.conf
    /sbin/service httpd condrestart
}
fi

%postun
if [ "$1" = "0" ]; then
    rm -f %{_sysconfdir}/httpd/conf.d/%{name}.conf
    egrep -q '^[[:space:]]*Include %{_sysconfdir}/httpd/conf/%{name}.conf' %{_sysconfdir}/httpd/conf/httpd.conf && {
        %{__perl} -pi -e 's|Include %{_sysconfdir}/httpd/conf/%{name}.conf||' %{_sysconfdir}/httpd/conf/httpd.conf
        /sbin/service httpd condrestart
    }
fi

%trigger -- apache
if [ -f %{_sysconfdir}/httpd/conf/httpd.conf ] ; then
    egrep -q '^[[:space:]]*Include %{_sysconfdir}/httpd/conf/%{name}.conf' %{_sysconfdir}/httpd/conf/httpd.conf || \
        echo 'Include %{_sysconfdir}/httpd/conf/%{name}.conf' >>%{_sysconfdir}/httpd/conf/httpd.conf
fi

%files
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/%{name}

%attr(0775,root,apache)	%{_localstatedir}/%{name}/img
# apache cannot write maxhight file in datadir. is that bad?
			%{_localstatedir}/%{name}/rrd
%{_localstatedir}/www/cgi-bin/%{name}

%config			%{_sysconfdir}/rc.d/init.d/%{name}
%config(noreplace)	%{_sysconfdir}/%{name}/*
%config(noreplace)	%{_sysconfdir}/httpd/conf/%{name}.conf

%{_mandir}/*/*
%doc [A-Z][A-Z]*
%doc doc/*.html doc/*.txt

%changelog
* Thu Oct  2 2003 Peter Hanecak <hanecak@megaloman.sk> 1.23-1
- adapted to Doors Linux
- .bz2 source archive
- changed group from Networking/Utilities to Applications/Internet

* Wed Jul 30 2003 Curtis Doty <Curtis@GreenKey.net>
- [1.23] bump and build
- fix on Shrike since libnet subsumed by perl-5.8 and we really only
  need Net:SNMP out of it anyways
- quick hacks to make apache 2 compatible

* Tue Dec 17 2002 Curtis Doty <Curtis@GreenKey.net>
- [1.18] with some cosmetic changes
- add perl-libnet dependency neede for at least Net::SMTP
- maxhight patch so apache puts temp files in imgcache dir not datadir
- prefer my config.dist

* Sat Nov 02 2002 Curtis Doty <Curtis@GreenKey.net>
- [1.16] with updated specfile
- fix perms on /var/smokeping so apache cannot write
- fork and distribute my own defailt config instead of patching the
  screwey one that comes in the tarball

* Tue Mar 12 2002 Curtis Doty <Curtis@GreenKey.net>
- [1.5] with a bunch of my additions including SysV init script

* Tue Feb 19 2002 Curtis Doty <Curtis@GreenKey.net>
- new rpm package [1.1]
